Index: LMDZ5/trunk/libf/dyn3dmem/dynredem_loc.F90
===================================================================
--- LMDZ5/trunk/libf/dyn3dmem/dynredem_loc.F90	(revision 2299)
+++ LMDZ5/trunk/libf/dyn3dmem/dynredem_loc.F90	(revision 2299)
@@ -0,0 +1,269 @@
+SUBROUTINE dynredem0_loc(fichnom,iday_end,phis)
+!
+!-------------------------------------------------------------------------------
+! Write the NetCDF restart file (initialization).
+!-------------------------------------------------------------------------------
+#ifdef CPP_IOIPSL
+  USE IOIPSL
+#endif
+  USE parallel_lmdz
+  USE mod_hallo
+  USE infotrac
+  USE netcdf, ONLY: NF90_CREATE, NF90_DEF_DIM, NF90_INQ_VARID, NF90_GLOBAL,    &
+                    NF90_CLOSE,  NF90_PUT_ATT, NF90_UNLIMITED, NF90_CLOBBER
+  USE dynredem_mod, ONLY: cre_var, put_var, err, modname, fil
+  IMPLICIT NONE
+  include "dimensions.h"
+  include "paramet.h"
+  include "comconst.h"
+  include "comvert.h"
+  include "comgeom.h"
+  include "temps.h"
+  include "ener.h"
+  include "logic.h"
+  include "description.h"
+  include "serre.h"
+  include "iniprint.h"
+!===============================================================================
+! Arguments:
+  CHARACTER(LEN=*), INTENT(IN) :: fichnom          !--- FILE NAME
+  INTEGER,          INTENT(IN) :: iday_end         !--- 
+  REAL,             INTENT(IN) :: phis(ijb_u:ije_u)!--- GROUND GEOPOTENTIAL
+!===============================================================================
+! Local variables:
+  INTEGER :: iq, l
+  INTEGER, PARAMETER :: length=100
+  REAL    :: tab_cntrl(length)                     !--- RUN PARAMETERS TABLE
+  REAL    :: phis_glo(ip1jmp1)
+!   For NetCDF:
+  CHARACTER(LEN=30) :: unites
+  INTEGER :: indexID
+  INTEGER :: rlonuID, rlonvID, rlatuID, rlatvID
+  INTEGER :: sID, sigID, nID, vID, timID
+  INTEGER :: yyears0, jjour0, mmois0
+  REAL    :: zan0, zjulian, hours
+!===============================================================================
+  modname='dynredem0'; fil=fichnom
+  CALL Gather_field_u(phis,phis_glo,1)
+  IF(mpi_rank/=0) RETURN
+
+#ifdef CPP_IOIPSL
+  CALL ymds2ju(annee_ref, 1, iday_end, 0.0, zjulian)
+  CALL ju2ymds(zjulian, yyears0, mmois0, jjour0, hours)
+#else
+! set yyears0, mmois0, jjour0 to 0,1,1 (hours is not used)
+  yyears0=0
+  mmois0=1
+  jjour0=1
+#endif        
+
+  tab_cntrl(:)  = 0.
+  tab_cntrl(1)  = REAL(iim)
+  tab_cntrl(2)  = REAL(jjm)
+  tab_cntrl(3)  = REAL(llm)
+  tab_cntrl(4)  = REAL(day_ref)
+  tab_cntrl(5)  = REAL(annee_ref)
+  tab_cntrl(6)  = rad
+  tab_cntrl(7)  = omeg
+  tab_cntrl(8)  = g
+  tab_cntrl(9)  = cpp
+  tab_cntrl(10) = kappa
+  tab_cntrl(11) = daysec
+  tab_cntrl(12) = dtvr
+  tab_cntrl(13) = etot0
+  tab_cntrl(14) = ptot0
+  tab_cntrl(15) = ztot0
+  tab_cntrl(16) = stot0
+  tab_cntrl(17) = ang0
+  tab_cntrl(18) = pa
+  tab_cntrl(19) = preff
+
+!    .....    parameters for zoom    ......   
+  tab_cntrl(20) = clon
+  tab_cntrl(21) = clat
+  tab_cntrl(22) = grossismx
+  tab_cntrl(23) = grossismy
+!
+  IF ( fxyhypb )   THEN
+    tab_cntrl(24) = 1.
+    tab_cntrl(25) = dzoomx
+    tab_cntrl(26) = dzoomy
+    tab_cntrl(27) = 0.
+    tab_cntrl(28) = taux
+    tab_cntrl(29) = tauy
+  ELSE
+    tab_cntrl(24) = 0.
+    tab_cntrl(25) = dzoomx
+    tab_cntrl(26) = dzoomy
+    tab_cntrl(27) = 0.
+    tab_cntrl(28) = 0.
+    tab_cntrl(29) = 0.
+    IF( ysinus )  tab_cntrl(27) = 1.
+  END IF
+  tab_cntrl(30) = REAL(iday_end)
+  tab_cntrl(31) = REAL(itau_dyn + itaufin)
+! start_time: start_time of simulation (not necessarily 0.)
+  tab_cntrl(32) = start_time
+
+!--- File creation
+  CALL err(NF90_CREATE(fichnom,NF90_CLOBBER,nid))
+
+!--- Some global attributes
+  CALL err(NF90_PUT_ATT(nid,NF90_GLOBAL,"title","Fichier demarrage dynamique"))
+
+!--- Dimensions
+  CALL err(NF90_DEF_DIM(nid,"index", length, indexID))
+  CALL err(NF90_DEF_DIM(nid,"rlonu", iip1,   rlonuID))
+  CALL err(NF90_DEF_DIM(nid,"rlatu", jjp1,   rlatuID))
+  CALL err(NF90_DEF_DIM(nid,"rlonv", iip1,   rlonvID))
+  CALL err(NF90_DEF_DIM(nid,"rlatv", jjm,    rlatvID))
+  CALL err(NF90_DEF_DIM(nid,"sigs",  llm,        sID))
+  CALL err(NF90_DEF_DIM(nid,"sig",   llmp1,    sigID))
+  CALL err(NF90_DEF_DIM(nid,"temps", NF90_UNLIMITED, timID))
+
+!--- Define and save invariant fields
+  CALL put_var(nid,"controle","Parametres de controle" ,[indexID],tab_cntrl)
+  CALL put_var(nid,"rlonu"   ,"Longitudes des points U",[rlonuID],rlonu)
+  CALL put_var(nid,"rlatu"   ,"Latitudes des points U" ,[rlatuID],rlatu)
+  CALL put_var(nid,"rlonv"   ,"Longitudes des points V",[rlonvID],rlonv)
+  CALL put_var(nid,"rlatv"   ,"Latitudes des points V" ,[rlatvID],rlatv)
+  CALL put_var(nid,"nivsigs" ,"Numero naturel des couches s"    ,[sID]  ,nivsigs)
+  CALL put_var(nid,"nivsig"  ,"Numero naturel des couches sigma",[sigID],nivsig)
+  CALL put_var(nid,"ap"      ,"Coefficient A pour hybride"      ,[sigID],ap)
+  CALL put_var(nid,"bp"      ,"Coefficient B pour hybride"      ,[sigID],bp)
+  CALL put_var(nid,"presnivs",""                                ,[sID]  ,presnivs)
+! covariant <-> contravariant <-> natural conversion coefficients
+  CALL put_var(nid,"cu","Coefficient de passage pour U",[rlonuID,rlatuID],cu)
+  CALL put_var(nid,"cv","Coefficient de passage pour V",[rlonvID,rlatvID],cv)
+  CALL put_var(nid,"aire","Aires de chaque maille"     ,[rlonvID,rlatuID],aire)
+  CALL put_var(nid,"phisinit","Geopotentiel au sol"    ,[rlonvID,rlatuID],phis_glo)
+
+!--- Define fields saved later
+  WRITE(unites,"('days since ',i4,'-',i2.2,'-',i2.2,' 00:00:00')"),&
+               yyears0,mmois0,jjour0
+  CALL cre_var(nid,"temps","Temps de simulation",[timID],unites)
+  CALL cre_var(nid,"ucov" ,"Vitesse U"  ,[rlonuID,rlatuID,sID,timID])
+  CALL cre_var(nid,"vcov" ,"Vitesse V"  ,[rlonvID,rlatvID,sID,timID])
+  CALL cre_var(nid,"teta" ,"Temperature",[rlonvID,rlatuID,sID,timID])
+  DO iq=1,nqtot
+    CALL cre_var(nid,tname(iq),ttext(iq),[rlonvID,rlatuID,sID,timID])
+  END DO
+  CALL cre_var(nid,"masse","Masse d air"    ,[rlonvID,rlatuID,sID,timID])
+  CALL cre_var(nid,"ps"   ,"Pression au sol",[rlonvID,rlatuID    ,timID])
+  CALL err(NF90_CLOSE (nid))
+
+  WRITE(lunout,*)TRIM(modname)//': iim,jjm,llm,iday_end',iim,jjm,llm,iday_end
+  WRITE(lunout,*)TRIM(modname)//': rad,omeg,g,cpp,kappa',rad,omeg,g,cpp,kappa
+
+END SUBROUTINE dynredem0_loc
+!
+!-------------------------------------------------------------------------------
+
+
+!-------------------------------------------------------------------------------
+!
+SUBROUTINE dynredem1_loc(fichnom,time,vcov,ucov,teta,q,masse,ps)
+!
+!-------------------------------------------------------------------------------
+! Purpose: Write the NetCDF restart file (append).
+!-------------------------------------------------------------------------------
+  USE parallel_lmdz
+  USE mod_hallo
+  USE infotrac
+  USE control_mod
+  USE netcdf,   ONLY: NF90_OPEN,  NF90_NOWRITE, NF90_GET_VAR, NF90_INQ_VARID,  &
+                      NF90_CLOSE, NF90_WRITE,   NF90_PUT_VAR, NF90_NoErr
+  USE dynredem_mod, ONLY: dynredem_write_u, dynredem_write_v, dynredem_read_u, &
+                          err, modname, fil, msg
+  IMPLICIT NONE
+  include "dimensions.h"
+  include "paramet.h"
+  include "description.h"
+  include "comvert.h"
+  include "comgeom.h"
+  include "temps.h"
+  include "iniprint.h"
+!===============================================================================
+! Arguments:
+  CHARACTER(LEN=*), INTENT(IN) :: fichnom              !-- FILE NAME
+  REAL, INTENT(IN)    ::  time                         !-- TIME
+  REAL, INTENT(IN)    ::  vcov(ijb_v:ije_v,llm)        !-- V COVARIANT WIND
+  REAL, INTENT(IN)    ::  ucov(ijb_u:ije_u,llm)        !-- U COVARIANT WIND
+  REAL, INTENT(IN)    ::  teta(ijb_u:ije_u,llm)        !-- POTENTIAL TEMPERATURE
+  REAL, INTENT(INOUT) ::     q(ijb_u:ije_u,llm,nqtot)  !-- TRACERS
+  REAL, INTENT(IN)    :: masse(ijb_u:ije_u,llm)        !-- MASS PER CELL
+  REAL, INTENT(IN)    ::    ps(ijb_u:ije_u)            !-- GROUND PRESSURE
+!===============================================================================
+! Local variables:
+  INTEGER :: l, iq, nid, vID, ierr, nid_trac, vID_trac
+  INTEGER, SAVE :: nb=0
+  INTEGER, PARAMETER :: length=100
+  REAL               :: tab_cntrl(length) ! tableau des parametres du run
+  CHARACTER(LEN=256) :: var, dum
+  LOGICAL            :: lread_inca
+!===============================================================================
+
+!$OMP MASTER
+  IF(mpi_rank==0) THEN !++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+  modname='dynredem1_loc'; fil=fichnom
+  fil=fichnom
+  CALL err(NF90_OPEN(fil,NF90_WRITE,nid),"open",fil)
+
+!--- Write/extend time coordinate
+  nb = nb + 1
+  var="temps"
+  CALL err(NF90_INQ_VARID(nid,var,vID),"inq",var)
+  CALL err(NF90_PUT_VAR(nid,vID,[time]),"put",var)
+  WRITE(lunout,*)TRIM(modname)//": Saving for ", nb, time
+
+!--- Rewrite control table (itaufin undefined in dynredem0)
+  var="controle"
+  CALL err(NF90_INQ_VARID(nid,var,vID),"inq",var)
+  CALL err(NF90_GET_VAR(nid,vID,tab_cntrl),"get",var)
+  tab_cntrl(31)=DBLE(itau_dyn + itaufin)
+  CALL err(NF90_INQ_VARID(nid,var,vID),"inq",var)
+  CALL err(NF90_PUT_VAR(nid,vID,tab_cntrl),"put",var)
+  END IF               !++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+!$OMP END MASTER
+
+!--- Save fields
+  CALL dynredem_write_u(nid,"ucov" ,ucov ,llm)
+  CALL dynredem_write_v(nid,"vcov" ,vcov ,llm)
+  CALL dynredem_write_u(nid,"teta" ,teta ,llm)
+  CALL dynredem_write_u(nid,"masse",masse,llm)
+  CALL dynredem_write_u(nid,"ps"   ,ps   ,1)
+
+!--- Tracers in file "start_trac.nc" (added by Anne)
+!$OMP MASTER
+  lread_inca=.FALSE.; fil="start_trac.nc"
+  IF(type_trac=='inca') INQUIRE(FILE=fil,EXIST=lread_inca)
+  IF(lread_inca) CALL err(NF90_OPEN(fil,NF90_NOWRITE,nid_trac),"open")
+!$OMP END MASTER
+!$OMP BARRIER
+
+!--- Save tracers
+  DO iq=1,nqtot; var=tname(iq); ierr=-1
+    IF(lread_inca) THEN                  !--- Possibly read from "start_trac.nc"
+!$OMP MASTER      
+      fil="start_trac.nc"
+      ierr=NF90_INQ_VARID(nid_trac,var,vID_trac)
+      dum='inq'; IF(ierr==NF90_NoErr) dum='fnd'
+      WRITE(lunout,*)msg(dum,var)
+!$OMP END MASTER
+!$OMP BARRIER
+      IF(ierr==NF90_NoErr) CALL dynredem_read_u(nid_trac,var,q(:,:,iq),llm)
+    END IF
+    fil=fichnom
+    CALL dynredem_write_u(nid,var,q(:,:,iq),llm)
+  END DO
+
+!$OMP MASTER
+  IF(mpi_rank==0) THEN !++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+  CALL err(NF90_CLOSE(nid),"close")
+  fil="start_trac.nc"
+  IF(lread_inca) CALL err(NF90_CLOSE(nid_trac),"close")
+  END IF               !++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+!$OMP END MASTER
+
+END SUBROUTINE dynredem1_loc
+
Index: LMDZ5/trunk/libf/dyn3dmem/dynredem_mod.F90
===================================================================
--- LMDZ5/trunk/libf/dyn3dmem/dynredem_mod.F90	(revision 2298)
+++ LMDZ5/trunk/libf/dyn3dmem/dynredem_mod.F90	(revision 2299)
@@ -1,206 +1,276 @@
-!
-! $Id$
-!
 MODULE dynredem_mod
 
-CONTAINS
-
-  SUBROUTINE dynredem_write_u(ncid,id,var,ll)
   USE dimensions_mod
   USE parallel_lmdz
   USE mod_hallo
-  IMPLICIT NONE
-    INTEGER          :: ncid
-    CHARACTER(LEN=*) :: id
-    REAL             :: var(ijb_u:ije_u,ll)
-    REAL,ALLOCATABLE,SAVE  :: var_tmp(:,:)
-    REAL,ALLOCATABLE,SAVE  :: var_glo(:)
-    INTEGER          :: ll
-    INTEGER          :: count(4)
-    INTEGER          :: start(4)
-    INTEGER          :: l
-    INTEGER          :: nvarid
-    INTEGER          :: ierr
-    INCLUDE 'netcdf.inc'    
+  USE netcdf
+  PRIVATE
+  PUBLIC :: dynredem_write_u, dynredem_write_v, dynredem_read_u, err
+  PUBLIC :: cre_var, get_var1, put_var, fil, modname, msg
+  CHARACTER(LEN=256), SAVE :: fil, modname
+  INTEGER,            SAVE :: nvarid
+
+
+CONTAINS
+
+
+!===============================================================================
+!
+SUBROUTINE dynredem_write_u(ncid,id,var,ll)
+!
+!===============================================================================
+  IMPLICIT NONE
+!===============================================================================
+! Arguments:
+  INTEGER,          INTENT(IN) :: ncid
+  CHARACTER(LEN=*), INTENT(IN) :: id
+  REAL,             INTENT(IN) :: var(ijb_u:ije_u,ll)
+  INTEGER,          INTENT(IN) :: ll
+!===============================================================================
+! Local variables:
+  REAL, ALLOCATABLE, SAVE :: var_tmp(:,:), var_glo(:)
+  INTEGER :: start(4), count(4), l, ierr
+!===============================================================================
+  start(:)=[1,1,1,1]; count(:)=[iip1,jjp1,1,1]
+
+!$OMP MASTER
+  IF(mpi_rank==0) CALL err(NF90_INQ_VARID(ncid,id,nvarid),"inq",id)
+!$OMP END MASTER
+
+!$OMP MASTER
+  ALLOCATE(var_tmp(ijb_u:ije_u,ll),var_glo(ip1jmp1))
+!$OMP END MASTER
+!$OMP BARRIER
+
+!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+  DO l=1,ll; var_tmp(:,l)=var(:,l); END DO
+  DO l=1,ll
+    CALL gather_field_u(var_tmp(:,l),var_glo,1)
+    IF(mpi_rank==0) THEN
+    !$OMP MASTER
+      start(3)=l
+      CALL err(NF90_PUT_VAR(ncid,nvarid,var_glo,start,count),"put",id)
+    !$OMP END MASTER
+    END IF
+  END DO
+!$OMP BARRIER
+!$OMP MASTER
+  DEALLOCATE(var_glo,var_tmp)
+!$OMP END MASTER
+!$OMP BARRIER
+  
+END SUBROUTINE dynredem_write_u
+!
+!===============================================================================
+
+
+!===============================================================================
+!
+SUBROUTINE dynredem_write_v(ncid,id,var,ll)
+!
+!===============================================================================
+  IMPLICIT NONE
+!===============================================================================
+! Arguments:
+  INTEGER,          INTENT(IN) :: ncid
+  CHARACTER(LEN=*), INTENT(IN) :: id
+  REAL,             INTENT(IN) :: var(ijb_v:ije_v,ll)
+  INTEGER,          INTENT(IN) :: ll
+!===============================================================================
+! Local variables:
+  REAL, ALLOCATABLE, SAVE :: var_tmp(:,:), var_glo(:)
+  INTEGER :: start(4), count(4), l, ierr
+!===============================================================================
+  start(:)=[1,1,1,1]; count(:)=[iip1,jjm,1,1]
+
+!$OMP MASTER
+  IF(mpi_rank==0) CALL err(NF90_INQ_VARID(ncid,id,nvarid),"inq",id)
+!$OMP END MASTER
+
+!$OMP MASTER
+  ALLOCATE(var_tmp(ijb_v:ije_v,ll),var_glo(ip1jm))
+!$OMP END MASTER
+!$OMP BARRIER
+
+!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+  DO l=1,ll; var_tmp(:,l)=var(:,l); END DO
+  DO l=1,ll
+    CALL gather_field_v(var_tmp(:,l),var_glo,1)
+    IF(mpi_rank==0) THEN
+    !$OMP MASTER
+      start(3)=l
+      CALL err(NF90_PUT_VAR(ncid,nvarid,var_glo,start,count),"put",id)
+    !$OMP END MASTER
+    END IF
+  END DO
+!$OMP BARRIER
+!$OMP MASTER
+  DEALLOCATE(var_glo,var_tmp)
+!$OMP END MASTER
+!$OMP BARRIER
+  
+END SUBROUTINE dynredem_write_v
+!
+!===============================================================================
+
+
+!===============================================================================
+!
+SUBROUTINE dynredem_read_u(ncid,id,var,ll)
+!
+!===============================================================================
+  IMPLICIT NONE
+!===============================================================================
+! Arguments:
+  INTEGER,          INTENT(IN)  :: ncid
+  CHARACTER(LEN=*), INTENT(IN)  :: id
+  REAL,             INTENT(OUT) :: var(ijb_u:ije_u,ll)
+  INTEGER,          INTENT(IN)  :: ll
+!===============================================================================
+! Local variables:
+  REAL, ALLOCATABLE, SAVE :: var_tmp(:,:), var_glo(:)
+  INTEGER :: start(4), count(4), l, ierr
+!===============================================================================
+  start(:)=[1,1,1,1]; count(:)=[iip1,jjp1,1,1]
+
+!$OMP MASTER
+  IF(mpi_rank==0) CALL err(NF90_INQ_VARID(ncid,id,nvarid),'inq',id)
+!$OMP END MASTER
+
+!$OMP MASTER
+  ALLOCATE(var_tmp(ijb_u:ije_u,ll),var_glo(ip1jmp1))
+!$OMP END MASTER
+!$OMP BARRIER
+
+  DO l=1,ll
+    IF(mpi_rank==0) THEN
+    !$OMP MASTER
+      start(3)=l
+      CALL err(NF90_GET_VAR(ncid,nvarid,var_glo,start,count),"get",id)
+    !$OMP END MASTER
+    END IF
+    CALL scatter_field_u(var_glo,var_tmp(:,l),1)
+  END DO
+
+!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+  DO l=1,ll; var(:,l)=var_tmp(:,l); END DO
     
-    count(:)=(/ iip1,jjp1,1,1 /)
-    start(:)=(/ 1,1,1,1 /)
-    
-!$OMP MASTER    
-   IF (mpi_rank==0) THEN
-     ierr = NF_INQ_VARID(ncid, id, nvarid)
-     IF (ierr .NE. NF_NOERR) THEN
-       PRINT*, "Variable "//id//" n est pas definie"
-       CALL abort
-     ENDIF
-   ENDIF
-!$OMP END MASTER
-
-!$OMP MASTER
-    ALLOCATE(var_tmp(ijb_u:ije_u,ll))
-    ALLOCATE(var_glo(ip1jmp1))
-!$OMP END MASTER
-!$OMP BARRIER
-
-!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
-    DO l=1,ll
-      var_tmp(:,l)=var(:,l)
-    ENDDO
-
-    DO l=1,ll
-      CALL gather_field_u(var_tmp(:,l),var_glo,1)
-       IF (mpi_rank==0) THEN
-   !$OMP MASTER
-        start(3)=l
+!$OMP BARRIER
+!$OMP MASTER
+  DEALLOCATE(var_glo,var_tmp)
+!$OMP END MASTER
+!$OMP BARRIER
+  
+END SUBROUTINE dynredem_read_u    
+!
+!===============================================================================
+
+
+!===============================================================================
+!
+SUBROUTINE cre_var(ncid,var,title,did,units)
+!
+!===============================================================================
+  IMPLICIT NONE
+!===============================================================================
+! Arguments:
+  INTEGER,                    INTENT(IN) :: ncid
+  CHARACTER(LEN=*),           INTENT(IN) :: var, title
+  INTEGER,                    INTENT(IN) :: did(:)
+  CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: units
+!===============================================================================
 #ifdef NC_DOUBLE
-        ierr = NF_PUT_VARA_DOUBLE (ncid,nvarid,start,count,var_glo)
+  CALL err(NF90_DEF_VAR(ncid,var,NF90_DOUBLE,did,nvarid),"inq",var)
 #else
-        ierr = NF_PUT_VARA_REAL (ncid,nvarid,start,count,var_glo)
+  CALL err(NF90_DEF_VAR(ncid,var,NF90_FLOAT ,did,nvarid),"inq",var)
 #endif
-   !$OMP END MASTER
-       ENDIF
-    ENDDO
-    
-  !$OMP BARRIER
-  !$OMP MASTER
-    DEALLOCATE(var_tmp)
-    DEALLOCATE(var_glo)
-  !$OMP END MASTER
-  !$OMP BARRIER
-  
-  END SUBROUTINE dynredem_write_u
-      
-  SUBROUTINE dynredem_write_v(ncid,id,var,ll)
-  USE dimensions_mod
-  USE parallel_lmdz
-  USE mod_hallo
-  IMPLICIT NONE
-    INTEGER          :: ncid
-    CHARACTER(LEN=*) :: id
-    REAL             :: var(ijb_v:ije_v,ll)
-    REAL,ALLOCATABLE,SAVE  :: var_tmp(:,:)
-    REAL,ALLOCATABLE,SAVE  :: var_glo(:)
-    INTEGER          :: ll
-    INTEGER          :: count(4)
-    INTEGER          :: start(4)
-    INTEGER          :: l
-    INTEGER          :: nvarid
-    INTEGER          :: ierr
-    INCLUDE 'netcdf.inc'    
-    
-    count(:)=(/ iip1,jjm,1,1 /)
-    start(:)=(/ 1,1,1,1 /)
-    
-!$OMP MASTER    
-   IF (mpi_rank==0) THEN
-     ierr = NF_INQ_VARID(ncid, id, nvarid)
-     IF (ierr .NE. NF_NOERR) THEN
-       PRINT*, "Variable "//id//" n est pas definie"
-       CALL abort
-     ENDIF
-   ENDIF
-!$OMP END MASTER
- 
-!$OMP MASTER
-    ALLOCATE(var_tmp(ijb_v:ije_v,ll))
-    ALLOCATE(var_glo(ip1jm))
-!$OMP END MASTER
-!$OMP BARRIER
-
-!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
-    DO l=1,ll
-      var_tmp(:,l)=var(:,l)
-    ENDDO
-
-    DO l=1,ll
-      CALL gather_field_v(var_tmp(:,l),var_glo,1)
-       IF (mpi_rank==0) THEN
-   !$OMP MASTER
-        start(3)=l
-#ifdef NC_DOUBLE
-        ierr = NF_PUT_VARA_DOUBLE (ncid,nvarid,start,count,var_glo)
-#else
-        ierr = NF_PUT_VARA_REAL (ncid,nvarid,start,count,var_glo)
-#endif
-   !$OMP END MASTER
-       ENDIF
-    ENDDO
-    
-  !$OMP BARRIER
-  !$OMP MASTER
-    DEALLOCATE(var_tmp)
-    DEALLOCATE(var_glo)
-  !$OMP END MASTER
-  !$OMP BARRIER
-  
-  END SUBROUTINE dynredem_write_v
-
-  SUBROUTINE dynredem_read_u(ncid,id,var,ll)
-  USE dimensions_mod
-  USE parallel_lmdz
-  USE mod_hallo
-  IMPLICIT NONE
-    INTEGER          :: ncid
-    CHARACTER(LEN=*) :: id
-    REAL             :: var(ijb_u:ije_u,ll)
-    REAL,ALLOCATABLE,SAVE  :: var_tmp(:,:)
-    REAL,ALLOCATABLE,SAVE  :: var_glo(:)
-    INTEGER          :: ll
-    INTEGER          :: count(4)
-    INTEGER          :: start(4)
-    INTEGER          :: l
-    INTEGER          :: nvarid
-    INTEGER          :: ierr
-    INCLUDE 'netcdf.inc'    
-    
-    count(:)=(/ iip1,jjp1,1,1 /)
-    start(:)=(/ 1,1,1,1 /)
-    
-!$OMP MASTER    
-   IF (mpi_rank==0) THEN
-     ierr = NF_INQ_VARID(ncid, id, nvarid)
-     IF (ierr .NE. NF_NOERR) THEN
-       PRINT*, "Variable "//id//" n est pas definie"
-       CALL abort
-     ENDIF
-   ENDIF
-!$OMP END MASTER
- 
-!$OMP MASTER
-    ALLOCATE(var_tmp(ijb_u:ije_u,ll))
-    ALLOCATE(var_glo(ip1jmp1))
-!$OMP END MASTER
-!$OMP BARRIER
-
-
-    DO l=1,ll
-       IF (mpi_rank==0) THEN
-   !$OMP MASTER
-        start(3)=l
-#ifdef NC_DOUBLE
-        ierr = NF_GET_VARA_DOUBLE (ncid,nvarid,start,count,var_glo)
-#else
-        ierr = NF_GET_VARA_REAL (ncid,nvarid,start,count,var_glo)
-#endif
-   !$OMP END MASTER
-       ENDIF
-       CALL scatter_field_u(var_glo,var_tmp(:,l),1)
-    ENDDO
-
-!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
-    DO l=1,ll
-      var(:,l)=var_tmp(:,l)
-    ENDDO
-    
-  !$OMP BARRIER
-  !$OMP MASTER
-    DEALLOCATE(var_tmp)
-    DEALLOCATE(var_glo)
-  !$OMP END MASTER
-  !$OMP BARRIER
-  
-  END SUBROUTINE dynredem_read_u    
-  
+  IF(title/="")      CALL err(NF90_PUT_ATT(ncid,nvarid,"title",title),var)
+  IF(PRESENT(units)) CALL err(NF90_PUT_ATT(ncid,nvarid,"units",units),var)
+
+END SUBROUTINE cre_var
+!
+!===============================================================================
+
+
+!===============================================================================
+!
+SUBROUTINE put_var(ncid,var,title,did,v,units)
+!
+!===============================================================================
+  IMPLICIT NONE
+!===============================================================================
+! Arguments:
+  INTEGER,                    INTENT(IN) :: ncid
+  CHARACTER(LEN=*),           INTENT(IN) :: var, title
+  INTEGER,                    INTENT(IN) :: did(:)
+  REAL,                       INTENT(IN) :: v(:)
+  CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: units
+!===============================================================================
+  INTEGER :: nd, k, nn(2)
+  IF(     PRESENT(units)) CALL cre_var(ncid,var,title,did,units)
+  IF(.NOT.PRESENT(units)) CALL cre_var(ncid,var,title,did)
+  CALL err(NF90_ENDDEF(ncid))
+  nd=SIZE(did)
+  DO k=1,nd; CALL err(NF90_INQUIRE_DIMENSION(ncid,did(k),len=nn(k))); END DO
+  IF(nd==1) CALL err(NF90_PUT_VAR(ncid,nvarid,RESHAPE(v,nn(1:1))),var)
+  IF(nd==2) CALL err(NF90_PUT_VAR(ncid,nvarid,RESHAPE(v,nn(1:2))),var)
+  CALL err(NF90_REDEF(ncid))
+END SUBROUTINE put_var
+!
+!===============================================================================
+
+
+!===============================================================================
+!
+FUNCTION msg(typ,nam)
+!
+!===============================================================================
+  IMPLICIT NONE
+!===============================================================================
+! Arguments:
+  CHARACTER(LEN=256)                     :: msg    !--- STANDARDIZED MESSAGE
+  CHARACTER(LEN=*),           INTENT(IN) :: typ    !--- TYPE OF OPERATION
+  CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: nam    !--- FIELD NAME
+!===============================================================================
+  SELECT CASE(typ)
+    CASE('open');  msg="Opening failed for <"//TRIM(fil)//">"
+    CASE('close'); msg="Closing failed for <"//TRIM(fil)//">"
+    CASE('get');   msg="Reading failed for <"//TRIM(nam)//">"
+    CASE('put');   msg="Writting failed for <"//TRIM(nam)//">"
+    CASE('inq');   msg="Missing field <"//TRIM(nam)//">"
+    CASE('fnd');   msg="Found field <"//TRIM(nam)//">"
+  END SELECT
+  msg=TRIM(msg)//" in file <"//TRIM(fil)//">"
+
+END FUNCTION msg
+!
+!===============================================================================
+
+
+!===============================================================================
+!
+SUBROUTINE err(ierr,typ,nam)
+!
+!===============================================================================
+  IMPLICIT NONE
+!===============================================================================
+! Arguments:
+  INTEGER,                    INTENT(IN) :: ierr   !--- NetCDF ERROR CODE
+  CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: typ    !--- TYPE OF OPERATION
+  CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: nam    !--- FIELD NAME
+!===============================================================================
+  IF(ierr==NF90_NoERR) RETURN
+  IF(.NOT.PRESENT(typ)) THEN
+    CALL ABORT_gcm(modname,NF90_STRERROR(ierr),ierr)
+  ELSE
+    CALL ABORT_gcm(modname,msg(typ,nam),ierr)
+  END IF
+
+END SUBROUTINE err
+!
+!===============================================================================
+
 END MODULE dynredem_mod   
+
     
     
